;@(#)drvinmnt.cpp, v 0.9, Jun 24 1999 (c) 1995 jerry g geiger 
; Version 0.9 by Michael Schwingen
; drvinmnt.xdd /.tos   install RSVF drivers (HS Modem) under Mint
;
; drvin.prg and the drivers should be run before Mint started,
;	you need 'rsvx.prg' to make the RSVF cookie available under MiNT
; this program is an 'xdd' module and executable program
;	define XDD or not when preprocessing
; defining HSM the executable will prefix the names of installed drives
;   with 'HS'
EINVFN		equ -32
EACCDN		equ -36
ERANGE		equ -64
O_RDONLY	equ 0
FIONREAD	equ $4601
FIONWRITE	equ $4602

	IMPORT ltoa
	EXPORT errno

MAXDEV		equ 16
;rsvf_tab offsets
f_fun		equ 0
f_flags		equ 4

;kernel
dos_tab		equ 12
k_vers 		equ 0
k_minvers	equ 2
k_trace		equ 20
k_debug		equ 24
k_alert		equ 28
k_fatal		equ 32
k_nap		equ 84

;MagiC 3 Offsets in Gertetreiber-Tabelle
mdev_open           equ 0
mdev_close          equ 4
mdev_read           equ 8
mdev_write          equ 12
mdev_stat           equ 16
mdev_lseek          equ 20
mdev_datime         equ 24             ;darf 0-ptr sein
mdev_ioctl          equ 28
mdev_delete         equ 32
mdev_getc           equ 36             ;darf 0-ptr sein
mdev_getline        equ 40             ;darf 0-ptr sein
mdev_putc           equ 44             ;darf 0-ptr sein
hsdev_name          equ 4


	.text 
start:    
	bra	install


; routines 
; for each driver in RSVF struct we need a pointer 
; with the above offsets we call the RSVE function

;long (*open) (FILEPTR *f);
dev_open:
	movea.l	4(sp), a0		;only argument: a0 = FD *file
	move.w	2(a0),d1		;get flags
	movem.l a1/a2,-(sp)
	clr.l	d0			;now get devno from f: aux field of fcookie
	move.w	18(a0),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2 		;address of table
	add.l	d0,a2			;address of entry in table
	move.w	d1,f_flags(a2)		; save file flags
	movea.l	f_fun(a2),a2 		;address of function table
	movea.l	mdev_open(a2),a2
	clr.l	a0			; a0 = FD *file
	jsr	(a2)
	movem.l	(sp)+,a1/a2
;	move.l	#EINVFN,d0
	rts


;long (*write) (FILEPTR *f, const char *buf, long bytes);
dev_write:
;long (*writeb) (FILEPTR *f, const char *buf, long bytes);
dev_writeb:
	movea.l	sp, a0
	movem.l d3/a2/a3,-(sp)
	movea.l	4(a0), a2		; a2 = FD *file
	clr.l	d0				;now get devno from f: aux field of fcookie
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; *84, size of rsvf_tab entry
	lea	rsvf_tab, a3 		;address of table
	add.l	d0,a3			;address of table entry
	movea.l	f_fun(a3),a3 		;address of function table
	movea.l	mdev_write(a3),a3
	move.l	12(a0), d0		; d0 = long count
	movea.l 8(a0), a1		; a1 = char *buffer
	clr.l	a0			; a0 = FD *file
	jsr	(a3)
		; d0 -> d3
		; if d0 < 0 return
		; if O_NDELAY return
w_loop:		; move.l	12(a0), d0	; d0 = long count
		; if d0 == d3 return
		; wait 100 ms
		; d0 = d0 - d3
		; a1 = buffer + d3
		; write again
		; if d0 < 0 return
		; d3 = d3 + d0
		; goto w_loop
	movem.l	(sp)+,d3/a2/a3
	rts

;long (*read) (FILEPTR *f, char *buf, long bytes);
dev_read:
;long (*readb) (FILEPTR *f, char *buf, long bytes);
dev_readb:
	movea.l	sp, a0
	movem.l a2-a4,-(sp)
	move.l	a0,a4			;just save
	movea.l	4(a0), a2		; a2 = FD *file
	move.w	2(a2),d1		;get flags
	clr.l	d0				;now get devno from f: aux field of fcookie
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2 		;address of table
	add.l	d0,a2			;address of table entry
	movea.l	f_fun(a2),a3 		;address of function table
	move.w	d1,f_flags(a2)		;get f_flags
	and.w	#256, d1
	bne	r_1			;O_NDELAY set
r_0:
	movea.l	mdev_ioctl(a3),a2 ;is there anything to read ?
	lea	l_junk, a1		; void *buff
	move.w	#FIONREAD, d0		;we should use a faster call :-)
	clr.l	a0
	jsr	(a2)		
	tst.l	l_junk
	bne	r_1			;yes : r_1
	movea.l kerninfo,a2		;no sleep 100 ms
	move.w	#100,-(sp)
	movea.l k_nap(a2),a2
	jsr	(a2)
	addq.l	#2,sp
	bra.s	r_0			;test again
r_1:
	movea.l	mdev_read(a3),a2
	move.l	12(a4), d0		; d0 = long count
	movea.l 8(a4), a1		; a1 = char *buffer
	clr.l	a0			; a0 = FD *file
	jsr	(a2)
	movem.l	(sp)+,a2-a4
	rts

;long (*lseek) (FILEPTR *f, long where, int whence);
dev_lseek:
	movea.l	sp, a0
	movem.l d1/a1/a2,-(sp)
	movea.l	4(a0), a2		; a2 = FD *file
	clr.l	d0			;now get devno from f: aux field of fcookie
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2	 	;address of table
	add.l	d0,a2			;address of fun table
	movea.l	f_fun(a2),a2 		;address of function table
	movea.l	mdev_lseek(a2),a2
	move.w	12(a0), d1		; d1 = int mode
	move.l	8(a0), d0		; d0 = long where
	clr.l	a0			; a0 = FD *file
	jsr	(a2)
	movem.l	(sp)+,d1/a1/a2
	rts

;long (*ioctl) (FILEPTR *f, int mode, void *buf);
; FD *file 2(a0) == &file->flags
dev_ioctl:
	movea.l	sp, a0
;testcalls	catch calls not supported by HSMODEM
;first for debug
	move.w	8(a0),	d0		;get mode for switch
	cmp.w	#$5801, d0		;return FILEPTR
	bne	n_1
	movea.l	10(a0), a1
	move.l	4(a0), (a1)
	clr.l	d0
	rts
n_1:
	cmp.w	#$5802, d0		;return rsvf_tab
	bne	n_2
	movea.l	10(a0), a1
	lea	rsvf_tab,a0
	move.l	a0, (a1)
	clr.l	d0
	rts

n_2:
	cmp.w	$541f, d0		; TIOCGSTATE
	bne		n_3
	movea.l	10(a0), a1
	clr.l	d0
	or.w	#$800, d0		; set TS_BLIND flag
	move.l	d0, (a1)		; return state
	clr.l	d0
	rts
n_3:
	cmp.w	#$5417, d0		; TIOCSFLAGS
	bne	n_fcntl
	movea.l	10(a0), a1		;TF_CAR TF_BRKINT not supported
	move.w	(a1), d0		;
	and.w	#$880, d0		; set ??
	beq	n_fcntl
	move.l	#ERANGE, d0		; return ERGANGE
	rts
;
n_fcntl:
	movem.l a1/a2,-(sp)
	movea.l	4(a0), a2		; a2 = FD *file
	clr.l	d0				;now get devno from f: aux field of fcookie
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2 		;address of table
	add.l	d0,a2			;address of fun table
	movea.l	f_fun(a2),a2 		;address of function table
	movea.l	mdev_ioctl(a2),a2
	movea.l	10(a0), a1		; a1 = void *buf
	move.w	8(a0), d0		; d0 = int cmd
	clr.l	a0			; a0 = FD *file
	jsr	(a2)
	movem.l	(sp)+,a1/a2
	rts

;long (*datime) (FILEPTR *f, short *timeptr, int rwflag);
dev_datime:
	movea.l	sp, a0
	movem.l a1/a2,-(sp)
	movea.l	4(a0), a2		; a2 = FD *file
	clr.l	d0			;now get devno from f: aux field of fcookie
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2 		;address of table
	add.l	d0,a2			;address of fun table
	movea.l	f_fun(a2),a2 		;address of function table
	movea.l	mdev_datime(a2),a2
	beq	no_datime
	move.w	12(a0), d0		; d0 = int setflag
	movea.l	8(a0), a1		; a1 = int d[2]
	clr.l	a0			; a0 = FD *file
	jsr	(a2)
	movem.l	(sp)+,a1/a2
	rts
no_datime:
	move.l	#EINVFN,d0
	rts

;long (*close) (FILEPTR *f, int pid);
dev_close:
	movea.l	sp, a0
	movem.l a1/a2,-(sp)
	movea.l	4(a0), a2		; a2 = FD *file
	clr.l	d0			;now get devno from f: aux field of fcookie
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2	 	;address of table
	add.l	d0,a2			;address of fun table
	movea.l	f_fun(a2),a2	 	;address of function table
	movea.l	mdev_close(a2),a2
	move.l	8(a0), d0
	clr.l	a0			; a0 = FD *file
	jsr	(a2)
	movem.l	(sp)+,a1/a2
	rts

;long (*select) (FILEPTR *f, long proc, int mode);
dev_select:	; /* simulate with stat value don't works
		; cause Harun's dev_stat returns nonsense */
	;movem.l	a2,-(sp)
	move.l	a2,-(sp)
	movea.l	8(sp),a2
	move.w	18(a2),d0		;f->fc.aux  12+6   is index in rsvf_tab
	asl.l	#3, d0			; * 8, size of rsvf_tab entry
	lea	rsvf_tab, a2	 	;address of table
	add.l	d0,a2			;address of fun table
	movea.l	f_fun(a2),a2	 	;address of function table
	movea.l	mdev_ioctl(a2),a2

	lea	l_junk, a1		; void *buf
	move.w	16(sp), d0		; mode -> d0
	cmp.w	#O_RDONLY, d0
	bne	s_write
	move.w	#FIONREAD,d0		; mode
	bra.s	s_callit
s_write:
	move.w	#FIONWRITE,d0
s_callit:
	clr.l	a0
	jsr	(a2)
	tst.l	l_junk
	bne	s_okay
	clr.l	d0
	move.l	(sp)+,a2
	;movem.l	(sp)+,a2
	rts
s_okay:
	moveq.l	#1, d0
	move.l	(sp)+,a2
	rts
;void (*unselect) (FILEPTR *f, long proc, int mode);
dev_unselect:
	rts


; install we make Dcntl() call for each driver in
; RSVF cookie structure

; struct kerinfo * Dcntl( short cmd, char *name, struct dev_descr *dev_des);
; this is what we pass on the call:
;DEV_INSTALL	0xde02
;name out of RSVF struct
;dev_descr:
;struct dev_descr {
;	DEVDRV	*driver;
;	short	dinfo;
;	short	flags;
;	struct tty *tty;
;	long	drvsize;		/* size of DEVDRV struct */
;	long	reserved[3];
;};

;typedef struct devdrv {
;	long (*open) (FILEPTR *f);
;	long (*write) (FILEPTR *f, const char *buf, long bytes);
;	long (*read) (FILEPTR *f, char *buf, long bytes);
;	long (*lseek) (FILEPTR *f, long where, int whence);
;	long (*ioctl) (FILEPTR *f, int mode, void *buf);
;	long (*datime) (FILEPTR *f, short *timeptr, int rwflag);
;	long (*close) (FILEPTR *f, int pid);
;	long (*select) (FILEPTR *f, long proc, int mode);
;	void (*unselect) (FILEPTR *f, long proc, int mode);
;	long (*writeb) (FILEPTR *f, const char *buf, long bytes);
;	long (*readb) (FILEPTR *f, char *buf, long bytes);
;	void *res1
;	void *res2
;/* what about: scatter/gather io for DMA devices...
; *	long ARGS_ON_STACK (*writev)	P_((FILEPTR *f, const struct iovec *iov, long cnt));
; *	long ARGS_ON_STACK (*readv)	P_((FILEPTR *f, const struct iovec *iov, long cnt));
; */
;} DEVDRV;
devdrv:
	.dc.l	dev_open
	.dc.l	dev_write
	.dc.l	dev_read
	.dc.l	dev_lseek
	.dc.l	dev_ioctl
	.dc.l	dev_datime
	.dc.l	dev_close
	.dc.l	dev_select
	.dc.l	dev_unselect
	.dc.l	dev_writeb
	.dc.l	dev_readb
dev_descr:
	.dc.l	devdrv
dev_descr_dinfo:
	.dc.w	0
	.dc.w	0
	.dc.l	0
	.dc.l	44		; 11 * (long *) (4 bytes)
	.dc.l	0,0,0

; we need a table with all the pointers from RSVF cookie
; and some algorithm to get the right pointer by f->fc.aux what is our index
;	funtable, tty_ptr, ...

;	funtable.l, f_flags.w, x_flags.w
rsvf_tab:
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
	.dc.l	0,0
rsvf_devno:
	.dc.l	0
	.dc.l	0

l_junk:
	.dc.l	0
w_junk:
	.dc.w	0	

kerninfo:
	.dc.l 0

resident_end:
	.dc.w 0

install:
	.if XDD
	move.l	sp, savestack
	move.l	4(sp), kerninfo
	movem.l	d2-d6/a2-a5,-(sp)
	.if DEBUG
	move.l	sp, savestack2
	.endif
	.else
	move.l	4(sp), ourbp
	.endif
;print msg
	lea	msg, a0
	jsr	printit

; get cookie
	.if XDD
	jsr	get_p_cookies
	.else
	pea	get_p_cookies
	move.w	#38,-(sp)
	trap	#14 			;XBIOS Supexec
	addq.l	#6,sp
	.endif

	move.l	d0,a0
	bne	go_on
;print msg
no_cookie:
	lea	nocookie, a0
	jsr	printit
	bra	not_installed
	.if XDD
no_MiNT:
	lea	noMiNT, a0
	jsr	printit
	bra	not_installed
	.endif
no_RSVF:
	lea	noRSVF, a0
	jsr	printit
	bra	not_installed

go_on:
	jsr	getcookie
	.ifne XDD
	tst.w	d1			; MiNT found ?
	beq	no_MiNT
	.endif
	move.l	d0, a5	;* RSVF 
	beq	no_RSVF
	clr.l	d6			;dev_descr.dinfo
	clr.l	d5			;rsvf->drvmode

loop1:
	.if DEBUG_RSVF
	lea	msg_loop1,a0
	jsr	printit
	move.l	a5,d0
	bsr	printhex
 	.endif
 	
	move.b	4(a5),d5		; ->drvmode in d5
	btst	#7,d5			; & 0x80
	beq	getnext			;no driver

loop1a:
	movea.l	(a5),a1			; ->name
	lea	_dev_n,a2
loop2:					;strcpy
	move.b	(a1)+,(a2)+
	bne	loop2

	clr.l	d1
	move.b	6(a5),d1		; ->devno
	move.l	d1, rsvf_devno

	btst	#6, d5			; & 0x40
	beq	biosdev			;no GEMDOS

	btst	#0, d5			; & 0x01
	beq	biosdev			;no routines

	move.l	(a5),d0			; ->name
	subq.l	#4,d0
	move.l	d0,a0			; ->mdev_drv

	move.l	d6,d0			; index
	cmpi.w	#MAXDEV,d0		; d0 >= MAXDEV ??
	bge	biosdev
	asl.l	#3,d0			; * 8 size of rsvf_tab entry
	lea	rsvf_tab,a1
	add.l	d0,a1
	move.l	(a0),(a1)		; save ->mdev_drv to rsvf_tab[index]
	beq	biosdev

;Dcntl() call install gemdos device
	move.w	d6, dev_descr_dinfo
	pea	dev_descr
	pea	dev_name
	move.w	#$de02,	-(sp)		;DEV_INSTALL	0xde02
	.if XDD
	move.l	#$130,d0
	movea.l	kerninfo,a0
	movea.l	dos_tab(a0),a0		;KERINFO->dostab
	asl.l	#2,d0
	add.l	d0,a0
	move.l	(a0),a0
	jsr		(a0)
	add.l	#10,sp
	.else
	move.w	#$130,	-(sp)
	trap	#1
	add.l	#12,sp
	.endif
	tst.l	d0
	beq	biosdev
	.ifne XDD
	move.l	d0, kerninfo
	.endif
	move.w	#1,is_installed
	.if DEBUG
	cmp.l	savestack2, sp
	beq	dbg2
	move.l	sp,a0
	jsr	stackerr
dbg2:
	.endif
	;print msg
	move.l	(a5),a0			; ->name
	bsr	printit
	move.l	d6,d0			; number (no)
	add.w	#$30,d0
	move.b	d0, channel
	lea	installed, a0
	jsr	printit
	addq.w	#1,d6			;increment index
	bra.s	getnext			;installed as gemdos device: no bios dev
biosdev:
; install bios device ??
	btst	#5,d5			; & 0x20
	beq	getnext
	;Dcntl() call
	move.l	rsvf_devno,-(sp)
	pea	dev_name
	move.w	#$de00,	-(sp)		;DEV_NEWTTY	0xde00
	.if XDD
	move.l	#$130,d0
	movea.l	kerninfo,a0
	movea.l	dos_tab(a0),a0		;KERINFO->dostab
	asl.l	#2,d0
	add.l	d0,a0
	move.l	(a0),a0
	jsr		(a0)
	add.l	#10,sp
	.if DEBUG
	cmp.l	savestack2,sp
	beq	dbg1
	move.l	sp,a0
	jsr	stackerr
dbg1:
	.endif
	.else
	move.w	#$130,	-(sp)
	trap	#1
	add.l	#12,sp
	.endif
	;print msg
	move.l	(a5),a0			; ->name
	bsr	printit
	lea	binstalled, a0
	jsr	printit

; get next entry. A5 points to current entry.
getnext:
	btst	#7,4(a5)		; ->drvmode
	beq	getnext2		; no driver - link to next struct
	addq	#8,a5			; else driver, next is at +8
	bra	loop1
getnext2:	
	tst.l	(a5)
	beq    loop_done
	.if DEBUG_RSVF
	lea	msg_getnext,a0
	jsr	printit
	.endif

	move.l  (a5),d0			; rsvf->next
	move.l	d0,a5
	bne	loop1			; valid pointer

	.if DEBUG_RSVF
	lea	msg_loopdone,a0
	jsr	printit
 	.endif
 	
;now all is done
loop_done:
	tst.w	is_installed
	beq	not_installed
	lea	exitmsg, a0
	jsr	printit

	.if	XDD
	movem.l	(sp)+,d2-d6/a2-a5
	cmp.l	savestack,sp
	beq	exit0
	move.l	sp,a0
	jsr	stackerr
	move.l	savestack,sp
exit0:
	move.l	#1,d0
	rts
stackerr:
	.if DEBUG
	move.l	savestack2, -(sp)
	.endif
	move.l	savestack, -(sp)
	move.l	a0, -(sp)
	pea	stack_err
	movea.l	kerninfo,a0
	movea.l k_alert(a0),a0
	jsr	(a0)
	.if DEBUG
	add.l	#16,sp
	.else
	add.l	#12,sp
	.endif
	rts
	.else
;exit okay : Ptermres
	clr.w 	-(sp)			;return 0
	move.l	#resident_end,d0
	move.l	ourbp,d1
	sub.l	d1,d0
	move.l	d0,-(sp)
	move.w	#$31,-(sp)
	trap	#1
	.endif

not_installed:
;print not installed
	lea	notinstalled, a0
	jsr	printit
	.if	XDD
	movem.l	(sp)+,d2-d6/a2-a5
	cmp.l	savestack,sp
	beq	exit1
	move.l	sp,a0
	jsr	stackerr
	move.l	savestack,sp
exit1:
	clr.l	d0
	rts

	.else

	clr.w	-(sp)	; Pterm0()
	trap	#1
	.endif
;Supervisor mode
get_p_cookies:
	move.l	$5a0.w,d0
	rts

getcookie:
	; cookie is in a0
	clr.w	d1
	clr.l	d0
	;tst MiNT (d1) and look for RSVF
cookieloop2:
	tst.l	(a0)
	beq	cookieret		; no more cookies
#ifndef XDD
	tst.w	d1
	beq	cookieloop0		;MiNT not found
#endif
	tst.l	d0
	bne	cookieret		;both cookies found, okay return
	bra.s	cookieloop1		; RSVF not found

	.ifne XDD
cookieloop0:
	cmp.l	#$4d694e54,(a0)		;'MiNT'
	bne	cookieloop1
	move.w	#1,d1
	addq.l	#8, a0
	bra.s	cookieloop2
	.endif
cookieloop1:
	cmp.l	#$52535666,(a0)		;'RSVf'
	beq	cookiefound
	cmp.l	#$52535646,(a0)		;'RSVF'
	beq	cookiefound
	addq.l	#8,a0
	bra.s	cookieloop2

cookiefound:
	addq.l	#4,a0
	move.l	(a0),d0
	addq.l	#4,a0
	bra.s	cookieloop2

cookieret:
	rts


printit:
	move.l	a0, -(sp)	;Cconws(a0)
	.if XDD
	move.l	#$9,d0
	movea.l	kerninfo,a0
	movea.l	dos_tab(a0),a0		;KERINFO->dostab
	asl.l	#2,d0
	add.l	d0,a0
	move.l	(a0),a0
	jsr		(a0)
	addq.l	#4,sp
	.if DEBUG
	move.l	sp, d0
	addq.l	#4,d0
	cmp.l	savestack2,d0
	beq		dbg0
	move.l	d0,a0
	jsr		stackerr
dbg0:
	.endif
	rts
	.else
	move.w	#9, -(sp)
	trap	#1
	addq.l	#6,sp
	rts
	.endif


	.if DEBUG_RSVF
; Print value in D0 in Hex. This assumes PureC libraries.
printhex:
	lea	buffer(pc),a0
	move.w	#16,d1
	bsr	ltoa
	bsr	printit
	rts
buffer:	ds.b	16	
errno:	ds.l 1
	.endif


	.data
is_installed:
	.dc.w	0

	.if XDD
	.if DEBUG
savestack2:
	.dc.l	0
	.endif
savestack:
	.else
ourbp:
	.endif
	.dc.l	0
	


what:
	.dc.b	'@','(','#',')'
	.if XDD
	.if HSM
	.dc.b	"hsminst.xdd"
	.else
	.dc.b	"drvinmnt.xdd"
	.endif
	.else
	.if HSM
	.dc.b	"hsminst.prg"
	.else
	.dc.b	"drvinmnt.prg"
	.endif
	.endif
	.dc.b	", v0.9 Jul 24 1999 (c)jerry g geiger",0
msg:
	.DC.b $1b,'p',"HSmodem DEVICE DRIVER interface Jul 24 1999",$1b,'q',$d,$a
	.DC.b 'v 0.9 (C) jerry g geiger',$d,$a,0

binstalled:
	.dc.b	" installed (bios)",$d,$a,0
installed:
	.dc.b	" installed ("
channel:
	.dc.b	" )",$d,$a,0
nocookie:
	.dc.b	"no cookies",$d,$a,0
noRSVF:
	.dc.b	"no RSVF cookie",$d,$a,0
	.ifne XDD
noMiNT:
	.dc.b	"no MiNT",$d,$a,0
	.endif
notinstalled:
	.dc.b	"no Gemdos device installed",$d,$a
exitmsg:
	.dc.b	$d,$a,0
	.if XDD
stack_err:
	.dc.b	"stack error %lx  %lx %lx",$d,$a,0 
	.endif
dev_name:
	.dc.b	'U',':',$5c,"DEV",$5c
	.if HSM
	.dc.b	'H','S'
	.endif

msg_loop1:	dc.b "loop1",13,10,0	
msg_loop1a:	dc.b "loop1a",13,10,0	
msg_getnext:	dc.b "getnext",13,10,0	
msg_loopdone:	dc.b "loop done",13,10,0	
	
_dev_n:
	.dc.b   0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
;
; here follows the stack, we can write into it :-)
